/*
	CNCPTS, CNC Program Transfer Software

	Copyright (C) 2001 Michael R. Donat, 5919 Hwy 191, Dodgeville, WI 53533
	(donat@donat.org)

	This file is part of CNCPTS.

	CNCPTS is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	CNCPTS is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with CNCPTS; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <string.h>
#include <stdio.h>
#include <conio.h>
#include <ctype.h>
#include <stdlib.h>
#include <math.h>
#include <dos.h>
#include <time.h>
#include "cncpts.h"
#include "serial.h"
#include "support.h"
#include "transfer.h"

int ncselect;
char *part;
time_t tsec,oldtsec,oldtsec2;

int main(){
	FILE *fp;
	int eFlag=0;
	if(!load_config()) exit(0);
	redrawmain();
	logfile(STATUS,"CNCPTS v%d.%d Starting up",VERSION_MAJOR,VERSION_MINOR);
	errsound(STARTUP);
  	errstr=listnfs;
   window(2,4,79,lines-1);
   clrscr();
   cprintf("Starting up.......\r\n");
   if((fp=fopen(FILE_PARTS,"r"))==NULL) {
   	errsound(ERROR);
      }
   else fclose(fp);
	if(!list_load()) exit(0);
	if(!list_sort()) exit(0);
	while(eFlag!=2) {
		redrawmain();
		nclist.start=0;
	   nclist.length=0;
      eFlag=select_nc();
		if(eFlag==1) restart();
	   }
	list_free();
   textmode(C80);
   textcolor(LIGHTGRAY);
   textbackground(BLACK);
   clrscr();
	errsound(SHUTDOWN);
   logfile(STATUS,"CNCPTS v%d.%d Shutting down",VERSION_MAJOR,VERSION_MINOR);
	return 0;
	}
int restart() {
	list_free();
   window(2,4,79,lines-2);
   clrscr();
	errsound(RESTART);
   cprintf("Restarting.......\r\n");
	if(!load_config()) return 0;
	logfile(STATUS,"CNCPTS v%d.%d Restarting",VERSION_MAJOR,VERSION_MINOR);
	if(!list_load()) return 0;
	if(!list_sort()) return 0;
  	return 1;
	}
int select_nc() {
	FILE *fp;
   int index;
   int index2;
	int length;
   int ncs=0;
   int key=0;
   int exit_flag=0;
	int gotkey;
   int lastwasq=0;
	int select=0;
	int startx,starty;
   char *ncname[4];
   char sys[MAX_PATH];
	char *transstr="Transfer to which NC";
	length=strlen(transstr)+2;
  	_setcursortype(_NOCURSOR);
   window(2,4,79,lines-2);
   for(index=0;index<4;index++) {
   	if(nc[index].enable) {
			if(strlen(nc[index].name)>length) length=strlen(nc[index].name)+2;
      	ncs++;
         }
      }
	logfile(DEBUG3,"ncname length=%d",length);
	if(length>77) {
   	logfile(FATAL,"NC name too long. (>77)");
		errsound(DIE);
      exit(0);
      }
	index2=0;
   for(index=0;index<4;index++)
		if(nc[index].enable)
			ncname[index2++]=nc[index].name;
   if(ncs==0) {
	   logfile(FATAL,"No NCs enabled!");
   	errsound(DIE);
	   exit(1);
   	}
   if(ncs==1) {
		for(index=0;index<4;index++)
	      if(strcmp(ncname[0],nc[index].name)==0) ncselect=index;
		if(list_prune()) return select_part();
	   else return 0;
		}
	if(nc[ncselect].enable)
  		for(index=0;index<ncs;index++)
	      if(strcmp(ncname[index],nc[ncselect].name)==0) select=index;
   clrscr();
	startx=40-length/2-1;
	starty=(lines/2)-((4+ncs)/2)-3;
   gotoxy(startx,starty); cprintf("");
	for(index=0;index<length;index++) cprintf("");
   cprintf("");
	gotoxy(startx,starty+1); cprintf("");
   for(index=0;index<(length-strlen(transstr))/2;index++) cprintf(" ");
   cprintf(transstr);
	gotoxy(startx+length+1,starty+1); cprintf("");
	gotoxy(startx,starty+2); cprintf("");
	for(index=0;index<length;index++) cprintf("");
   cprintf("");
	for(index=0;index<ncs;index++) {
		gotoxy(startx,starty+3+index); cprintf("");
		for(index2=0;index2<length;index2++) cprintf(" ");
		cprintf("");
	   }
   gotoxy(startx,starty+3+index); cprintf("");
	for(index=0;index<length;index++) cprintf("");
   cprintf("");
   window(startx+2,starty+6,startx+length-1,starty+6+ncs);
   for(index=0;index<ncs;index++) {
     	cprintf("%s",ncname[index]);
      if(index<ncs-1) cprintf("\r\n");
      }
   textcolor(background);
  	textbackground(foreground);
  	gotoxy(1,select+1); cprintf("%s",ncname[select]);
   textcolor(foreground);
  	textbackground(background);
	displaytime(&t);
	oldt.ti_hour=t.ti_hour;
  	oldt.ti_min=t.ti_min;
  	oldt.ti_sec=t.ti_sec;
	keyflush();
	while(!exit_flag) {
      gotkey=0;
	   tsec = time(NULL);
   	if(tsec>=oldtsec+rdelay) {
	      oldtsec=tsec;
			if((fp=fopen(FILE_RESTART,"r"))!=NULL) {
		  		fclose(fp);
				system(STR_DEL_FILE_RESTART);
		   	errstr=listnfr;
				return 1;
				}
			}
   	gettime(&t);
   	if(t.ti_sec!=oldt.ti_sec || t.ti_min!=oldt.ti_min || t.ti_hour!=oldt.ti_hour) {
   		displaytime(&t);
   		oldt.ti_hour=t.ti_hour;
      	oldt.ti_min=t.ti_min;
      	oldt.ti_sec=t.ti_sec;
      	}

   	if(kbhit()) {
			gotkey=1;
		   window(startx+2,starty+6,startx+length-1,starty+6+ncs);
			key=getkey();
			if(lastwasq) {
				if(key==0x13b) return 1;
				else if(key==0x13c && rebuild) {
	   	      system(STR_DEL_FILE_PARTS);
   	   	   return 1;
	            }
				else if(key==0x13e) return 2;
				else if(key==0x13f) {
	  				sprintf(sys,"%s %s",editorpath,FILE_CONFIG);
  					logfile(STATUS,"Edit: calling %s",sys);
					system(sys);
				   tsec = time(NULL);
		      	oldtsec=tsec;
					keyflush();
   	      	}
            }
			if(key==0x11) lastwasq=1;
         else lastwasq=0;
         if(key==0x148 && select>0) {
			   textcolor(foreground);
   			textbackground(background);
		   	gotoxy(1,select+1); cprintf("%s",ncname[select]);
         	select--;
			   textcolor(background);
   			textbackground(foreground);
		   	gotoxy(1,select+1); cprintf("%s",ncname[select]);
				}
			else if(key==0x150 && select<ncs-1) {
			   textcolor(foreground);
   			textbackground(background);
		   	gotoxy(1,select+1); cprintf("%s",ncname[select]);
         	select++;
			   textcolor(background);
   			textbackground(foreground);
   			gotoxy(1,select+1); cprintf("%s",ncname[select]);
            }
		   textcolor(foreground);
 			textbackground(background);
         if(key==0xd) {
				for(index=0;index<4;index++)
            	if(strcmp(ncname[select],nc[index].name)==0) ncselect=index;
				if(list_prune()) return select_part();
	         else return 0;
            }
			}
		if(!gotkey) delay(keydelay);
      }
   return 2;
   }
int select_part() {
	FILE *fp;
	int key;
   int exit_flag=0;
   int gotkey;
	int index;
   int index2;
   int index3;
   int startx,starty;
   int buffer;
   int screen[160];
   char input[MAX_LENGTH]="";
   int length=0;
   int slength=0;
   int tlength=0;
	int cursbot=lines-10;
	int lastwasq=0;
   struct sublists sublist[MAX_LENGTH];
   int cursor=-1;
   int pagetop=0;
	char efile[MAX_PATH];
   FILE *efp;
   char ebuffer[MAX_PATH];
   char sys[MAX_PATH];
   window(2,4,79,lines-2);
	clrscr();
	if(plength>60) {
   	logfile(FATAL,"Part name too long. (>60)");
		errsound(DIE);
      exit(0);
      }
	slength=plength+1;
	if(slength>45)
		startx=38-slength/2+5;
   else startx=38-slength/2-1;
	if(nclist.length<lines-9) {
		starty=(lines/2)-(nclist.length/2)-4;
      tlength=nclist.length;
      }
   else {
   	starty=1;
		tlength=lines-9;
      }
   gotoxy(startx,starty); cprintf("");
	for(index=0;index<slength;index++) cprintf("");
   cprintf("");
   gotoxy(startx-12,starty+1); cprintf("Part Number:");
	for(index=0;index<slength;index++) cprintf(" ");
   cprintf("");
	gotoxy(startx,starty+2); cprintf("");
	for(index=0;index<slength;index++) cprintf("");
   cprintf("Ŀ");
	for(index=0;index<tlength;index++) {
		gotoxy(startx,starty+3+index); cprintf("");
		for(index2=0;index2<slength;index2++) cprintf(" ");
      if(index==0) cprintf("");
      else if(index==tlength-1) cprintf("");
      else cprintf("");
	   }
   gotoxy(startx,starty+3+index); cprintf("");
	for(index=0;index<slength;index++) cprintf("");
   cprintf("");

	displaytime(&t);
	oldt.ti_hour=t.ti_hour;
  	oldt.ti_min=t.ti_min;
  	oldt.ti_sec=t.ti_sec;
   gettext(startx+2,starty+4,startx+slength+1,starty+4,screen);
	sublist[0].start=nclist.start;
   sublist[0].length=nclist.length-1;
   window(startx+2,starty+6,startx+slength+1,starty+6+tlength);
   if(sublist[0].length<0) {
   	logfile(FATAL,"No Parts in list");
      errsound(DIE);
      exit(1);
      }
  	if(sublist[0].length>=0)
	  	for(index=0;(index<sublist[0].length+1) && (index<tlength);index++) {
			cprintf("%s",sublist[0].start[index]+2);
   	   if((index<(sublist[0].length)) && (index<tlength-1)) cprintf("\r\n");
	      }
	else cprintf("(NONE MATCHING)");
   buffer=0x00b0 + ((foreground & 0x0f)<<8) + ((background & 0x0f) << 12);
	if(sublist[length].length>=tlength) {
     	index2=round((float)((tlength-2)*tlength)/(sublist[length].length+1));
		if(index2<1) index2=1;
      }
   else
	  	index2=tlength-2;
	if(pagetop>0) {
     	index3=round((float)((tlength-2)*pagetop)/sublist[length].length);
		if((index2+index3)>tlength-2) index3=tlength-2-index2;
      }
   else
     	index3=0;
	for(index=0;index<index3;index++)
     	puttext(startx+slength+3,starty+7+index,startx+slength+3,starty+7+index,&buffer);
	buffer=0x00db + ((foreground & 0x0f)<<8) + ((background & 0x0f) << 12);
 	for(index=0;index<index2;index++)
     	puttext(startx+slength+3,starty+7+index,startx+slength+3,starty+7+index,&buffer);
   buffer=0x00b0 + ((foreground & 0x0f)<<8) + ((background & 0x0f) << 12);
	for(;index<tlength-2;index++)
     	puttext(startx+slength+3,starty+7+index,startx+slength+3,starty+7+index,&buffer);
   window(startx+2,starty+4,startx+slength+1,starty+4);
	_setcursortype(_NORMALCURSOR);
   tsec = oldtsec = oldtsec2 = time(NULL);
	keyflush();
	while(!exit_flag){
		gotkey=0;
	   tsec = time(NULL);
   	if(tsec>=oldtsec2+rdelay) {
	      oldtsec2=tsec;
			if((fp=fopen(FILE_RESTART,"r"))!=NULL) {
		  		fclose(fp);
				system(STR_DEL_FILE_RESTART);
		   	errstr=listnfr;
				return 1;
				}
			}
   	if(tsec>=oldtsec+timeout_sel) {
			return 0;
			}
   	gettime(&t);
   	if (t.ti_sec!=oldt.ti_sec || t.ti_min!=oldt.ti_min || t.ti_hour!=oldt.ti_hour) {
   		displaytime(&t);
		   window(startx+2,starty+4,startx+slength+1,starty+4);
			gotoxy(length+1,1);
   		oldt.ti_hour=t.ti_hour;
      	oldt.ti_min=t.ti_min;
      	oldt.ti_sec=t.ti_sec;
      	}
   	if(kbhit()) {
			gotkey=1;
	      oldtsec=tsec;
			key=getkey();
			if(lastwasq) {
				if(key==0x13b) return 1;
				else if(key==0x13c && rebuild) {
	      	   system(STR_DEL_FILE_PARTS);
   	      	return 1;
	            }
				else if(key==0x13d && editenable) {
      	      part=sublist[length].start[cursor+pagetop];
				   if((efp=fopen(FILE_PARTS,"r"))==NULL) {
		   			errstr=listnft;
		   			logfile(WARNING,"Couldn't open part list. (%s)",FILE_PARTS);
						errsound(ERROR);
				      return 1;
			   	   }
					while(readline(ebuffer,efp)!=NULL) {
			   		if(ebuffer[0]==':') {
      					if(strcmp(ebuffer+1,part)==0) {
								if(readline(ebuffer,efp)!=NULL) {
   								if(ebuffer[0]!=':') strcpy(efile,ebuffer);
					            else {
                          		logfile(WARNING,"Format error in %s at %s",FILE_PARTS,part);
		         				   errsound(ERROR);
                     	      }
         				      }
			      	      else {
            	         	logfile(WARNING,"Unexpected EOF on read of %s",FILE_PARTS);
	      	   			   errsound(ERROR);
      	                  }
   	      				sprintf(sys,"%s %s",editorpath,efile);
	         				logfile(STATUS,"Edit: calling %s",sys);
								system(sys);
							   tsec = time(NULL);
						      oldtsec=tsec;
								keyflush();
								goto spag;
				            }
							}
				      }
			   	logfile(WARNING,"Part not found in list: %s",part+2);
					errsound(ERROR);
spag:
				   fclose(efp);
   	      	}
				else if(key==0x13e) return 2;
				else if(key==0x13f) {
  					sprintf(sys,"%s %s",editorpath,FILE_CONFIG);
	  				logfile(STATUS,"Edit: calling %s",sys);
					system(sys);
				   tsec = time(NULL);
			      oldtsec=tsec;
					keyflush();
	         	}
            }
			if(key==0x11) lastwasq=1;
         else lastwasq=0;
			if(key==0x1b) exit_flag=TRUE;
         else if(key>=0x20 && key<=0x7e && length<plength) {
				if(key>=0x61 && key<=0x7a)
            	key-=0x20;
            input[length++]=key;
            input[length]=0;
			   window(startx+2,starty+4,startx+slength+1,starty+4);
            cprintf("\r\n%s",input);
			   window(startx+2,starty+6,startx+slength+1,starty+6+tlength);
            sublist[length].start=sublist[length-1].start;
      		if(sublist[length-1].length>=0) {
   	         sublist[length].length=sublist[length-1].length;
      	   	while(sublist[length].start[0][length+1]!=input[length-1] && sublist[length].length>=0) {
						sublist[length].start++;
            	   sublist[length].length--;
               	}
	            while(sublist[length].start[sublist[length].length][length+1]!=input[length-1] && sublist[length].length>=0)
   	         	sublist[length].length--;
					}
            else sublist[length].length=-1;
         	pagetop=0;
         	cursor=-1;
            }
         else if(key==0x08 && length>0) {
            input[--length]=0;
			   window(startx+2,starty+4,startx+slength+1,starty+4);
            cprintf("\r\n%s",input);
         	pagetop=0;
         	cursor=-1;
            }
         else if(key==0x148 && pagetop+cursor>=0) {
         	if(pagetop>0 && cursor==0) pagetop--;
         	else cursor--;
            }
			else if(key==0x150 && (pagetop+cursor)<sublist[length].length){
         	if(cursor==cursbot) pagetop++;
            else cursor++;
            }
			else if(key==0x151 && (pagetop+cursor)<sublist[length].length){
            if(cursor==-1 && pagetop==0) cursor=0;
         	else if(cursor<cursbot && sublist[length].length-pagetop>=cursbot) cursor=cursbot;
				else if(cursor<cursbot && sublist[length].length-pagetop-cursor<cursbot) cursor=sublist[length].length-pagetop;
            else if(cursor==cursbot && sublist[length].length-pagetop-cursor>cursbot) pagetop+=cursbot;
            else if(cursor==cursbot && sublist[length].length-pagetop-cursor<=cursbot) pagetop=sublist[length].length-(cursbot);
				}
			else if(key==0x149 && (pagetop+cursor)>=0){
         	if(cursor>0) cursor=0;
            else if(cursor==0 && pagetop==0) cursor--;
            else if(cursor==0 && pagetop>=cursbot) pagetop-=cursbot;
            else if(cursor==0 && pagetop<cursbot) pagetop=0;
				}
			else if(key==0x0d) {
         	if(cursor<0 && sublist[length].length>0) cursor=0;
            else if(cursor<0 && sublist[length].length==0) cursor=0;
            else if(cursor>=0) {
	            part=sublist[length].start[cursor+pagetop];
            	return transfer();
               }
         	}
			else if(key==0x147 && cursor+pagetop>=0) {
         	if(cursor+pagetop>0) {cursor=0;pagetop=0;}
            else if(cursor+pagetop==0) {cursor=-1;pagetop=0;}
            }
			else if(key==0x14f && (pagetop+cursor)<sublist[length].length) {
            if(sublist[length].length<cursbot)
            	cursor=sublist[length].length;
         	else {cursor=cursbot; pagetop=sublist[length].length-(cursbot);}
         	}
		   window(startx+2,starty+6,startx+slength+1,starty+6+tlength);
         if(sublist[length].length>=0) {
	        	for(index=0;(index+pagetop<=sublist[length].length) && (index<tlength);index++) {
					if(index==cursor) {
					   textcolor(background);
					   textbackground(foreground);
                  }
               else {
                  textcolor(foreground);
					   textbackground(background);
						}
               puttext(startx+2,starty+index+6,startx+slength+1,starty+index+6,screen);
        			cprintf("%s",sublist[length].start[index+pagetop]+2);

     	      	if((index+pagetop<(sublist[length].length)) && (index<tlength-1)) cprintf("\r\n");
        			}
            for(;index<tlength;index++) puttext(startx+2,starty+index+6,startx+slength+1,starty+index+6,screen);
				}
			else {
         	cprintf("(NONE MATCHING)");
            for(index=1;index<tlength;index++) puttext(startx+2,starty+index+6,startx+slength+1,starty+index+6,screen);
				}
         textcolor(foreground);
		   textbackground(background);

		   buffer=0x00b0 + ((foreground & 0x0f)<<8) + ((background & 0x0f) << 12);
			if(sublist[length].length>=tlength) {
         	index2=round((float)((tlength-2)*tlength)/(sublist[length].length+1));
				if(index2<1) index2=1;
            }
         else
         	index2=tlength-2;
			if(pagetop>0) {
         	index3=round((float)((tlength-2)*pagetop)/sublist[length].length);
				if((index2+index3)>(tlength-2)) index3=tlength-2-index2;
            }
         else
         	index3=0;
			for(index=0;index<index3;index++)
     			puttext(startx+slength+3,starty+7+index,startx+slength+3,starty+7+index,&buffer);
		   buffer=0x00db + ((foreground & 0x0f)<<8) + ((background & 0x0f) << 12);
			for(;index<index2+index3;index++)
		     	puttext(startx+slength+3,starty+7+index,startx+slength+3,starty+7+index,&buffer);
		   buffer=0x00b0 + ((foreground & 0x0f)<<8) + ((background & 0x0f) << 12);
			for(;index<tlength-2;index++)
		     	puttext(startx+slength+3,starty+7+index,startx+slength+3,starty+7+index,&buffer);

			if(pagetop<=0&&cursor<0) {
			   window(startx+2,starty+4,startx+slength+1,starty+4);
  				gotoxy(length+1,1);
				_setcursortype(_NORMALCURSOR);
            }
         else _setcursortype(_NOCURSOR);
         }
  		if(!gotkey) delay(keydelay);
		}
	return 0;
	}

