/*
	CNCPTS, CNC Program Transfer Software

	Copyright (C) 2001 Michael R. Donat, 5919 Hwy 191, Dodgeville, WI 53533
	(donat@donat.org)

	This file is part of CNCPTS.

	CNCPTS is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	CNCPTS is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with CNCPTS; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <conio.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include <dos.h>
#include <ctype.h>
#include <stdlib.h>
#include "cncpts.h"
#include "support.h"

char *errstr;
char *listnfs="Startup: Rebuilding Part list.";
char *listnfr="Restart: Rebuilding Part list.";
char *listnft="Transfer: Rebuilding Part list.";

int	foreground,
		background,
		lines,
      interdelay,
		logstartup,
		logtransfer,
		editenable,
		firstlast,
		rdelay,
      timeout_key,
      timeout_sel,
      timeout_trans,
      errlevel=STATUS,
		esound,
		rebuild,
		keydelay,
      term;
char editorpath[256];
int	plength=15;
char	**list;
int	number=0;
int   dup=0;
int 	EXIT_flag=FALSE;
long start;
struct time t;
struct time oldt;
struct dosdate_t d;
struct routers nc[4];
struct sublists nclist;
char str_levels[7][8]={"DEBUG4","DEBUG3","DEBUG2","DEBUG1","STATUS", "WARNING", "FATAL"};

int logfile(enum levels level,const char *format,...) {
	FILE *fp;
   va_list args;
	if(errlevel>level) return 0;
   va_start(args,format);
	if((fp=fopen(FILE_LOG,"a"))!=NULL) {
		gettime(&t);
      _dos_getdate(&d);
	   fprintf(fp,"%04d%02d%02d-%02d%02d%02d:%s: ",d.year,d.month,d.day,t.ti_hour,t.ti_min,t.ti_sec,str_levels[level]);
		vfprintf(fp,format,args);
      fprintf(fp,"\n");
		fclose(fp);
		}
	else cprintf("\r\nUnable to open log file\r\n");
	va_end(args);
	return 1;
	}
char *readline(char *string,FILE *fp) {
	char buffer[MAX_LENGTH];
   int length,
   	 index,
       index_2,
       parsed;
   while(1) {
		index=0;
      index_2=0;
      parsed=0;
   	if(!fgets(buffer,MAX_LENGTH,fp))
      	return NULL;
      length=strlen(buffer);
      buffer[length-1]=0;
      while((buffer[index]==0x20) || buffer[index]==0x09)
			index++;
		while(!parsed) {
      	if(buffer[index]!='#') {
         	string[index_2]=buffer[index];
      		if(string[index_2]==0)
            	parsed=1;
				index++;
            index_2++;
            }
         else {
         	string[index_2]=0;
            parsed=1;
            }
         }
         if(strlen(string))
         	return string;
      }
   }
int writeprgline(char *string,FILE *fp) {
	return fprintf(fp,"%s\n",string);
   }
char *readprgline(char *string,FILE *fp) {
	char readbuffer[MAX_LENGTH];
   int length,
   	 index,
       index_2,
       parsed;
   while(1) {
		index=0;
      index_2=0;
      parsed=0;
   	if(!fgets(readbuffer,MAX_LENGTH,fp))
      	return NULL;
      length=strlen(readbuffer);
      readbuffer[length-1]=0;
      while((readbuffer[index]==0x20) || readbuffer[index]==0x09)
			index++;
		while(!parsed) {
        	string[index_2]=readbuffer[index];
     		if(string[index_2]==0)
           	parsed=1;
			index++;
         index_2++;
         }
         if(strlen(string))
         	return string;
      }
   }
int load_config() {
	FILE *fp;
   char buffer[MAX_LENGTH];
   char config[MAX_LENGTH];
      int position;
   int length,
   	 index=0,
       index_2=0;
	foreground=LIGHTGRAY;
	background=BLUE;
	lines=25;
   interdelay=0;
	logstartup=0;
	logtransfer=0;
	rdelay=30;
   timeout_key=60;
   timeout_sel=120;
   timeout_trans=10;
   keydelay=4;
   errlevel=1;
   editenable=1;
   firstlast=0;
   rebuild=1;
   esound=1;
   term=0;
   for(index=0;index<4;index++) {
   	sprintf(nc[index].name,"NC%d",index+1);
   	nc[index].commport=2;
   	nc[index].baudrate=9600;
   	nc[index].databits=7;
   	nc[index].stopbits=1;
   	nc[index].parity=2;
   	nc[index].trans=0;
		nc[index].delay=0;
   	nc[index].enable=1;
      }
   if((fp=fopen(FILE_CONFIG,"r"))==NULL) {
   	logfile(WARNING,"Couldn't open config file, using defaults (%s)",FILE_CONFIG);
		errsound(ERROR);
      return 0;
      }
	while(readline(buffer,fp)!=NULL) {
		index=0;
      index_2=0;
      position=0;
      while(isalpha(buffer[position]) || (buffer[position]>='0' && buffer[position]<='9'))
			config[index_2++] = toupper(buffer[position++]);
      config[index_2]=0;
      while(buffer[position]==' ' || buffer[position]=='=' || buffer[position]==0x09)
      	position++;
      length = strlen(config);
		for (index=0; index<length; index++) {
      	config[index] = toupper(config[index]);
   		}
      if(strcmp("NC1COMM",config)==0) {
      	logfile(DEBUG4,"Got NC1COMM=%d",atoi(buffer+position));
      	nc[0].commport=atoi(buffer+position);
         }
      else if(strcmp("NC2COMM",config)==0) {
      	logfile(DEBUG4,"Got NC2COMM=%d",atoi(buffer+position));
      	nc[1].commport=atoi(buffer+position);
         }
      else if(strcmp("NC3COMM",config)==0) {
      	logfile(DEBUG4,"Got NC3COMM=%d",atoi(buffer+position));
      	nc[2].commport=atoi(buffer+position);
         }
      else if(strcmp("NC4COMM",config)==0) {
      	logfile(DEBUG4,"Got NC4COMM=%d",atoi(buffer+position));
      	nc[3].commport=atoi(buffer+position);
         }
      else if(strcmp("NC1BAUD",config)==0) {
      	logfile(DEBUG4,"Got NC1BAUD=%d",atoi(buffer+position));
      	nc[0].baudrate=atoi(buffer+position);
         }
      else if(strcmp("NC2BAUD",config)==0) {
      	logfile(DEBUG4,"Got NC2BAUD=%d",atoi(buffer+position));
      	nc[1].baudrate=atoi(buffer+position);
         }
      else if(strcmp("NC3BAUD",config)==0) {
      	logfile(DEBUG4,"Got NC3BAUD=%d",atoi(buffer+position));
      	nc[2].baudrate=atoi(buffer+position);
         }
      else if(strcmp("NC4BAUD",config)==0) {
      	logfile(DEBUG4,"Got NC4BAUD=%d",atoi(buffer+position));
      	nc[3].baudrate=atoi(buffer+position);
         }
      else if(strcmp("NC1DATA",config)==0) {
      	logfile(DEBUG4,"Got NC1DATA=%d",atoi(buffer+position));
      	nc[0].databits=atoi(buffer+position);
         }
      else if(strcmp("NC2DATA",config)==0) {
      	logfile(DEBUG4,"Got NC2DATA=%d",atoi(buffer+position));
      	nc[1].databits=atoi(buffer+position);
         }
      else if(strcmp("NC3DATA",config)==0) {
      	logfile(DEBUG4,"Got NC3DATA=%d",atoi(buffer+position));
      	nc[2].databits=atoi(buffer+position);
         }
      else if(strcmp("NC4DATA",config)==0) {
      	logfile(DEBUG4,"Got NC4DATA=%d",atoi(buffer+position));
      	nc[3].databits=atoi(buffer+position);
         }
      else if(strcmp("NC1STOP",config)==0) {
      	logfile(DEBUG4,"Got NC1STOP=%d",atoi(buffer+position));
      	nc[0].stopbits=atoi(buffer+position);
         }
      else if(strcmp("NC2STOP",config)==0) {
      	logfile(DEBUG4,"Got NC2STOP=%d",atoi(buffer+position));
      	nc[1].stopbits=atoi(buffer+position);
         }
      else if(strcmp("NC3STOP",config)==0) {
      	logfile(DEBUG4,"Got NC3STOP=%d",atoi(buffer+position));
      	nc[2].stopbits=atoi(buffer+position);
         }
      else if(strcmp("NC4STOP",config)==0) {
      	logfile(DEBUG4,"Got NC4STOP=%d",atoi(buffer+position));
      	nc[3].stopbits=atoi(buffer+position);
         }
      else if(strcmp("NC1PARITY",config)==0) {
      	logfile(DEBUG4,"Got NC1PARITY=%d",atoi(buffer+position));
      	nc[0].parity=atoi(buffer+position);
         }
      else if(strcmp("NC2PARITY",config)==0) {
      	logfile(DEBUG4,"Got NC2PARITY=%d",atoi(buffer+position));
      	nc[1].parity=atoi(buffer+position);
         }
      else if(strcmp("NC3PARITY",config)==0) {
      	logfile(DEBUG4,"Got NC3PARITY=%d",atoi(buffer+position));
      	nc[2].parity=atoi(buffer+position);
         }
      else if(strcmp("NC4PARITY",config)==0) {
      	logfile(DEBUG4,"Got NC4PARITY=%d",atoi(buffer+position));
      	nc[3].parity=atoi(buffer+position);
         }
      else if(strcmp("NC1TRANSFERMODE",config)==0) {
      	logfile(DEBUG4,"Got NC1TRANSFERMODE=%d",atoi(buffer+position));
      	nc[0].trans=atoi(buffer+position);
         }
      else if(strcmp("NC2TRANSFERMODE",config)==0) {
      	logfile(DEBUG4,"Got NC2TRANSFERMODE=%d",atoi(buffer+position));
      	nc[1].trans=atoi(buffer+position);
         }
      else if(strcmp("NC3TRANSFERMODE",config)==0) {
      	logfile(DEBUG4,"Got NC3TRANSFERMODE=%d",atoi(buffer+position));
      	nc[2].trans=atoi(buffer+position);
         }
      else if(strcmp("NC4TRANSFERMODE",config)==0) {
      	logfile(DEBUG4,"Got NC4TRANSFERMODE=%d",atoi(buffer+position));
      	nc[3].trans=atoi(buffer+position);
         }
      else if(strcmp("NC1NAME",config)==0) {
      	logfile(DEBUG4,"Got NC1NAME=%s",buffer+position);
      	strcpy(nc[0].name,buffer+position);
			for(index=0;index<4;index++)
		      if(strcmp(nc[0].name,nc[index].name)==0 && index!=0) {
		      	logfile(FATAL,"NC name identical: %s",nc[index].name);
					if(esound) errsound(DIE);
					exit(BAD);
               }
         }
      else if(strcmp("NC2NAME",config)==0) {
      	logfile(DEBUG4,"Got NC2NAME=%s",buffer+position);
      	strcpy(nc[1].name,buffer+position);
			for(index=0;index<4;index++)
		      if(strcmp(nc[1].name,nc[index].name)==0 && index!=1) {
		      	logfile(FATAL,"NC name identical: %s",nc[index].name);
					if(esound) errsound(DIE);
					exit(BAD);
               }
         }
      else if(strcmp("NC3NAME",config)==0) {
      	logfile(DEBUG4,"Got NC3NAME=%s",buffer+position);
      	strcpy(nc[2].name,buffer+position);
			for(index=0;index<4;index++)
		      if(strcmp(nc[2].name,nc[index].name)==0 && index!=2) {
		      	logfile(FATAL,"NC name identical: %s",nc[index].name);
					if(esound) errsound(DIE);
					exit(BAD);
               }
         }
      else if(strcmp("NC4NAME",config)==0) {
      	logfile(DEBUG4,"Got NC4NAME=%s",buffer+position);
      	strcpy(nc[3].name,buffer+position);
			for(index=0;index<4;index++)
		      if(strcmp(nc[3].name,nc[index].name)==0 && index!=3) {
		      	logfile(FATAL,"NC name identical: %s",nc[index].name);
					if(esound) errsound(DIE);
					exit(BAD);
               }
         }
      else if(strcmp("NC1ENABLE",config)==0) {
      	logfile(DEBUG4,"Got NC1ENABLE=%d",atoi(buffer+position));
      	nc[0].enable=atoi(buffer+position);
         }
      else if(strcmp("NC2ENABLE",config)==0) {
      	logfile(DEBUG4,"Got NC2ENABLE=%d",atoi(buffer+position));
      	nc[1].enable=atoi(buffer+position);
         }
      else if(strcmp("NC3ENABLE",config)==0) {
      	logfile(DEBUG4,"Got NC3ENABLE=%d",atoi(buffer+position));
      	nc[2].enable=atoi(buffer+position);
         }
      else if(strcmp("NC4ENABLE",config)==0) {
      	logfile(DEBUG4,"Got NC4ENABLE=%d",atoi(buffer+position));
      	nc[3].enable=atoi(buffer+position);
         }
      else if(strcmp("NC1DELAY",config)==0) {
      	logfile(DEBUG4,"Got NC1DELAY=%d",atoi(buffer+position));
      	nc[0].delay=atoi(buffer+position);
         }
      else if(strcmp("NC2DELAY",config)==0) {
      	logfile(DEBUG4,"Got NC2DELAY=%d",atoi(buffer+position));
      	nc[1].delay=atoi(buffer+position);
         }
      else if(strcmp("NC3DELAY",config)==0) {
      	logfile(DEBUG4,"Got NC3DELAY=%d",atoi(buffer+position));
      	nc[2].delay=atoi(buffer+position);
         }
      else if(strcmp("NC4DELAY",config)==0) {
      	logfile(DEBUG4,"Got NC4DELAY=%d",atoi(buffer+position));
      	nc[3].delay=atoi(buffer+position);
         }
      else if(strcmp("INTERDELAY",config)==0) {
      	logfile(DEBUG4,"Got INTERDELAY=%d",atoi(buffer+position));
      	interdelay=atoi(buffer+position);
         }
      else if(strcmp("RESTARTDELAY",config)==0) {
      	logfile(DEBUG4,"Got RESTARTDELAY=%d",atoi(buffer+position));
      	rdelay=atoi(buffer+position);
         }
      else if(strcmp("KEYTIMEOUT",config)==0) {
      	logfile(DEBUG4,"Got KEYTIMEOUT=%d",atoi(buffer+position));
      	timeout_key=atoi(buffer+position);
         }
      else if(strcmp("KEYDELAY",config)==0) {
      	logfile(DEBUG4,"Got KEYDELAY=%d",atoi(buffer+position));
      	keydelay=atoi(buffer+position);
         }
      else if(strcmp("SELECTTIMEOUT",config)==0) {
      	logfile(DEBUG4,"Got SELECTTIMEOUT=%d",atoi(buffer+position));
      	timeout_sel=atoi(buffer+position);
         }
      else if(strcmp("TRANSFERTIMEOUT",config)==0) {
      	logfile(DEBUG4,"Got TRANSFERTIMEOUT=%d",atoi(buffer+position));
      	timeout_trans=atoi(buffer+position);
         }
      else if(strcmp("FOREGROUND",config)==0) {
      	logfile(DEBUG4,"Got FOREGROUND=%d",atoi(buffer+position));
      	foreground=atoi(buffer+position);
         }
      else if(strcmp("BACKGROUND",config)==0) {
      	logfile(DEBUG4,"Got BACKGROUND=%d",atoi(buffer+position));
      	background=atoi(buffer+position);
         }
      else if(strcmp("LINES",config)==0) {
      	logfile(DEBUG4,"Got LINES=%d",atoi(buffer+position));
      	lines=atoi(buffer+position);
         }
      else if(strcmp("TERM",config)==0) {
      	logfile(DEBUG4,"Got TERM=%d",atoi(buffer+position));
      	term=atoi(buffer+position);
         }
      else if(strcmp("ERRLEVEL",config)==0) {
      	logfile(DEBUG4,"Got ERRLEVEL=%d",atoi(buffer+position));
      	errlevel=atoi(buffer+position);
         }
      else if(strcmp("REBUILD",config)==0) {
      	logfile(DEBUG4,"Got REBUILD=%d",atoi(buffer+position));
      	rebuild=atoi(buffer+position);
         }
      else if(strcmp("SOUND",config)==0) {
      	logfile(DEBUG4,"Got SOUND=%d",atoi(buffer+position));
      	esound=atoi(buffer+position);
         }
      else if(strcmp("EDITENABLE",config)==0) {
      	logfile(DEBUG4,"Got EDITENABLE=%d",atoi(buffer+position));
      	editenable=atoi(buffer+position);
         }
      else if(strcmp("FIRSTLAST",config)==0) {
      	logfile(DEBUG4,"Got FIRSTLAST=%d",atoi(buffer+position));
      	firstlast=atoi(buffer+position);
         }
      else if(strcmp("EDITOR",config)==0) {
      	logfile(DEBUG4,"Got EDITOR=%s",buffer+position);
      	strcpy(editorpath,buffer+position);
         }
		}
	fclose(fp);
	return 1;
   }
int list_load() {
	FILE *fp;
   char buffer[MAX_LENGTH];
	int index=0,
       index2;
   if((fp=fopen(FILE_PARTS,"r"))==NULL) {
		if(rebuild) {
	   	logfile(WARNING,"Could not open part list, Rebuilding...");
			cprintf("%s\r\n",errstr);
			list_make();
		   if((fp=fopen(FILE_PARTS,"r"))==NULL) {
   			logfile(FATAL,"Unable to recreate part list. (%s)",FILE_PARTS);
				errsound(DIE);
				exit(BAD);
		      }
   	   }
		else {
	   	logfile(FATAL,"Could not open part list.");
         errsound(DIE);
         exit(BAD);
      	}
      }
	while(readline(buffer,fp)!=NULL) {
   	if(buffer[0]==':') {
      	number++;
         }
      }
	if((list=(char **)malloc(number * sizeof(char *))) == NULL) {
   	logfile(FATAL,"Not enough memory to allocate list buffer");
		errsound(DIE);
	   fclose(fp);
   	exit(BAD);
   	}
	fseek(fp,0,SEEK_SET);
	while(readline(buffer,fp)!=NULL) {
   	if(buffer[0]==':') {
			for(index2=0;index2<index;index2++) {
         	if(strcmp(buffer+1,list[index2])==0) {
            	logfile(WARNING,"duplicate warning: %s",buffer+3);
					errsound(ERROR);
					}
            }
			if(strlen(buffer+1)-2>60) {
	      	logfile(FATAL,"Part name too long (>60): %s",buffer+3);
				errsound(DIE);
            fclose(fp);
				exit(BAD);
            }
			if((list[index]=(char *)malloc(strlen(buffer))) == NULL) {
		   	logfile(FATAL,"Not enough memory to allocate part name buffer");
				errsound(DIE);
			   fclose(fp);
   			exit(BAD);
   			}
			strcpy(list[index],buffer+1);
         if((strlen(buffer+1)-2)>plength) plength=strlen(buffer+1)-2;
         index++;
         }
      }
   fclose(fp);
   return 1;
	}
list_make() {
	FILE *fpath;
	FILE *ftemp;
	FILE *fprg;
   FILE *fout;
   int num_parts;
   int num_parts_total=0;
	char flag;
   int index,index2;
   char *path;
   char product[MAX_LENGTH];
	char pathline[MAX_LENGTH];
	char sys[MAX_LENGTH];
	char prgfile[MAX_LENGTH];
	char prgline[MAX_LENGTH];
   if((fpath=fopen(FILE_PATHS,"r"))==NULL) {
   	logfile(FATAL,"Couldn't open path list. (%s)",FILE_PATHS);
		errsound(DIE);
      exit(BAD);
      }
	while(readline(pathline,fpath)!=NULL) {
		if(pathline[0]!=':') {
			fclose(fpath);
      	logfile(FATAL,"Format error in path file. (%s)",FILE_PATHS);
			errsound(DIE);
         exit(BAD);
         }
   	flag=pathline[1];
		path=pathline+3;
		sprintf(sys,"DIR /ON /B /S %s > %s",path,FILE_TEMP);
	   system(sys);
	   if((ftemp=fopen(FILE_TEMP,"r"))==NULL) {
	      logfile(FATAL,"Unable to open input file: %s",FILE_TEMP);
			errsound(DIE);
	      exit(BAD);
	   	}
	   if((fout=fopen(FILE_PARTS,"a"))==NULL) {
	      logfile(FATAL,"Unable to open output file: %s",FILE_PARTS);
			errsound(DIE);
			fclose(fpath);
			fclose(ftemp);
	      exit(BAD);
	   	}
		num_parts=0;
		while(readprgline(prgfile,ftemp)!=NULL) {
			num_parts++;
			index=index2=0;
		   if((fprg=fopen(prgfile+2,"r"))==NULL) {
	   	   logfile(FATAL,"Unable to open input file: %s",prgfile+2);
				errsound(DIE);
			   fclose(fout);
				fclose(ftemp);
				fclose(fpath);
	      	exit(BAD);
		   	}
			readprgline(prgline,fprg);
         if(prgline[0]!='%') logfile(WARNING,"Program format error '\%' %s",prgfile);
			readprgline(prgline,fprg);
         if(prgline[0]!='O') logfile(WARNING,"Program format error 'O' %s",prgfile);
			while(prgline[index]!='(' && prgline[index]!=0) index++;
	      index++;
			while(prgline[index]!=')' && prgline[index]!=0)
				product[index2++]=prgline[index++];
	      product[index2]=0;
			fclose(fprg);
			fprintf(fout,":%c:%s\n%s\n",flag,product,prgfile+2);
	   	}
	   fclose(ftemp);
		sprintf(sys,"DEL %s",FILE_TEMP);
	   system(sys);
	   fclose(fout);
		logfile(DEBUG2,"%4d/%4d parts loaded from path%s",num_parts,num_parts_total+=num_parts,pathline);
	   }                       //printf
	logfile(DEBUG2,"%d total parts loaded.",num_parts_total);
   fclose(fpath);
   return 1;
   }
int fornc(char cflag) {
	int flag;
   if(cflag>='0' && cflag<='9') flag=cflag-'0';
   else if(cflag>='A' && cflag<='F') flag=cflag-'A'+10;
   else return 0;
	switch(flag) {
   	case 0:
      	return 0;
      case 1:
      	if(ncselect==0                                             ) return 1;
         else return 0;
      case 2:
      	if(               ncselect==1                              ) return 1;
         else return 0;
      case 3:
      	if(ncselect==0 || ncselect==1                              ) return 1;
         else return 0;
      case 4:
      	if(                              ncselect==2               ) return 1;
         else return 0;
      case 5:
      	if(ncselect==0 ||                ncselect==2               ) return 1;
         else return 0;
      case 6:
      	if(               ncselect==1 || ncselect==2               ) return 1;
         else return 0;
      case 7:
      	if(ncselect==0 || ncselect==1 || ncselect==2               ) return 1;
         else return 0;
      case 8:
      	if(                                             ncselect==3) return 1;
         else return 0;
      case 9:
      	if(ncselect==0 ||                               ncselect==3) return 1;
         else return 0;
      case 10:
      	if(               ncselect==1 ||                ncselect==3) return 1;
         else return 0;
      case 11:
      	if(ncselect==0 || ncselect==1 ||                ncselect==3) return 1;
         else return 0;
      case 12:
      	if(                              ncselect==2 || ncselect==3) return 1;
         else return 0;
      case 13:
      	if(ncselect==0 ||                ncselect==2 || ncselect==3) return 1;
         else return 0;
      case 14:
      	if(               ncselect==1 || ncselect==2 || ncselect==3) return 1;
         else return 0;
      case 15:
      	if(ncselect==0 || ncselect==1 || ncselect==2 || ncselect==3) return 1;
         else return 0;
      default: return 0;
      }
   }
int list_prune() {
	int index;
   int index2;
	if(nclist.length) {free(nclist.start);nclist.start=NULL;nclist.length=0;}
	for(index=0;index<number;index++)
		if(fornc(list[index][0])) nclist.length++;
	if(!nclist.length) return 0;
	if((nclist.start=(char **)malloc(nclist.length * sizeof(char *))) == NULL) {
   	logfile(FATAL,"Not enough memory to allocate pruned buffer");
		errsound(DIE);
   	exit(BAD);
   	}
   index2=0;
	for(index=0;index<number;index++)
		if(fornc(list[index][0]))
      	nclist.start[index2++]=list[index];
	return 1;
   }
void list_free() {
	int index;
   if(number) {
      for(index=0;index<number;index++)
		   free(list[index]);
   	free(list);
		list=NULL;
   	number=0;
	   }
   }
int list_sort() {
	int index,
   	 index_2;
   char *temp;
	for(index=1;index<number;index++) {
   	temp=list[index];
      for(index_2=index-1;index_2>=0;index_2--) {
      	if(strcmp(temp+2,list[index_2]+2)<0) {
         	list[index_2+1]=list[index_2];
				}
         else break;
         }
      list[index_2+1]=temp;
      }
	return 1;
   }
int pause(delay) {
	int key;
   time_t timein;
   time_t timeout;
  	timein=timeout=time(NULL);
	while(!kbhit()) {
		timeout=time(NULL);
      if(timeout>timein+delay) {
	      return 0;
         }
      }
	if((key=getch())==0)
		key=getch()+0x100;
	return key;
   }
void displaytime(struct time *t) {
   char *ap="am";
   int hour=0;
   window(67,lines-1,67 + 12,lines-1);
   if(t->ti_hour >12) {hour=t->ti_hour-12; ap="pm";}
   else if (t->ti_hour > 0) {hour=t->ti_hour;}
   else hour = 12;
   cprintf("              %2d:%02d:%02d %s",hour,t->ti_min,t->ti_sec,ap);
	}
int getkey(){
	int key;
	if ((key=getch())==0)
		key=getch()+0x100;
	return key;
	}
void keyflush(void){
	while(kbhit()) {
		if(getch()==0)
			getch();
      }
	}
int round(float value){
	if(ceil(value+.5)==ceil(value)) return (int)floor(value);
	else return (int)ceil(value);
	}
int redrawmain() {
   int buffer;
	int index;
   if(lines==50)
      textmode(C4350);
   else textmode(C80);
   textcolor(foreground);
   textbackground(background);
   buffer=0x00d9 + ((foreground & 0x0f)<<8) + ((background & 0x0f) << 12);
	window(1,1,80,lines);
   cprintf("Ŀ");
   cprintf(" CNC Router Program Transfer Software v%01d.%01d          (C) 2001 Michael R. Donat ",VERSION_MAJOR,VERSION_MINOR);
   cprintf("Ĵ");
   for(index=lines-5;index>0;index--)
          //12345678901234567890123456789012345678901234567890123456789012345678901234567890
   cprintf("                                                                              ");
   cprintf(" Licensed under the GNU General Public License                                ");
   cprintf("");
   puttext(80,lines,80,lines,&buffer);
	return 1;
	}
int errsound(enum sounds select) {
	int index;
	if(esound) {
	  	switch(select) {
   		case ERROR:
      	   delay(300);
      		sound(800);
	         delay(600);
				nosound();
      	   break;
	   	case SUCCESS:
   	      delay(300);
      		sound(800);
         	delay(150);
				nosound();
   	      delay(50);
      		sound(800);
         	delay(150);
				nosound();
   	      delay(50);
      		sound(800);
         	delay(150);
				nosound();
   	      delay(100);
      	   switch(ncselect) {
	         	case 0:
			      	sound(500);
			         delay(150);
						nosound();
		      	   delay(50);
      				sound(500);
			         delay(150);
						nosound();
			         break;
         		case 1:
		      		sound(1100);
		         	delay(150);
						nosound();
			         delay(50);
      				sound(500);
		   	      delay(150);
						nosound();
		         	break;
	         	case 2:
			      	sound(500);
			         delay(150);
						nosound();
		      	   delay(50);
      				sound(1100);
			         delay(150);
						nosound();
			         break;
         		case 3:
		      		sound(1100);
		         	delay(150);
						nosound();
			         delay(50);
      				sound(1100);
		   	      delay(150);
						nosound();
		         	break;
	            }
   	      break;
   		case RESTART:
	         delay(300);
				for(index=800;index>500;index--) {sound(index);delay(1);}
				for(;index<1100;index++) {sound(index);delay(1);}
				nosound();
	         break;
   		case DIE:
      	   delay(300);
				sound(700);
				delay(300);
				nosound();
				delay(50);
				sound(700);
				delay(200);
				nosound();
				delay(50);
				sound(500);
				delay(70);
				nosound();
				delay(50);
				sound(700);
				delay(400);
				nosound();
      	   break;
	   	case STARTUP:
   	      delay(300);
				for(index=500;index<1100;index++) {sound(index);delay(1);}
				delay(50);
				nosound();
   	      break;
   		case SHUTDOWN:
	         delay(300);
				for(index=1100;index>500;index--) {sound(index);delay(1);}
				delay(50);
				nosound();
	         break;
			}
   }
	return 1;
   }

