/*
	CNCPTS, CNC Program Transfer Software

	Copyright (C) 2001 Michael R. Donat, 5919 Hwy 191, Dodgeville, WI 53533
	(donat@donat.org)

	This file is part of CNCPTS.

	CNCPTS is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	CNCPTS is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with CNCPTS; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef _SUPPORT_H
#define _SUPPORT_H

#define SIZE_NAME 30
#define MAX_PATH 64
#define MAX_PROGRAMS 16
#define BAD 1
struct routers {
   char name[SIZE_NAME];
	int commport;
   int baudrate;
   int databits;
   int stopbits;
   int parity;
	int trans;
	int delay;
	int enable;
   };
struct sublists {
	char **start;
   int length;
   };

enum levels {DEBUG4,DEBUG3,DEBUG2,DEBUG1,STATUS, WARNING, FATAL};
enum sounds {ERROR,SUCCESS, RESTART, DIE, STARTUP, SHUTDOWN};

extern char *errstr;
extern char *listnfs;
extern char *listnfr;
extern char *listnft;

extern int foreground;
extern int background;
extern int lines;
extern int interdelay;
extern int errlevel;
extern int rebuild;
extern int term;
extern int rdelay;
extern int timeout_key;
extern int timeout_trans;
extern int timeout_sel;
extern char unlockkey[33];
extern char editorpath[256];
extern int editenable;
extern int firstlast;
extern int keydelay;
extern int plength;
extern char	**list;
extern struct sublists nclist;
extern int number;
extern long start;
extern struct time t;
extern struct time oldt;
extern struct dosdate_t d;
extern struct routers nc[4];

int logfile(enum levels, const char *,...);
char *readline(char *,FILE *);
char *readprgline(char *,FILE *);
int load_config(void);
int list_load(void);
int list_make(void);
void list_free(void);
int list_sort(void);
int list_prune(void);
int pause(int);
void displaytime(struct time *);
int getkey(void);
void keyflush(void);
int round(float);
int redrawmain(void);
int errsound(enum sounds);

#endif
