/*
	CNCPTS, CNC Program Transfer Software

	Copyright (C) 2001 Michael R. Donat, 5919 Hwy 191, Dodgeville, WI 53533
	(donat@donat.org)

	This file is part of CNCPTS.

	CNCPTS is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	CNCPTS is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with CNCPTS; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>
#include <dos.h>
#include <time.h>
#include <string.h>
#include "support.h"
#include "serial.h"
#include "cncpts.h"
#include "transfer.h"
char file[MAX_PATH];
int transfer() {
   FILE *fp;
   char buffer[MAX_PATH];
   if((fp=fopen(FILE_PARTS,"r"))==NULL) {
   	errstr=listnft;
   	logfile(WARNING,"Couldn't open part list. (%s)",FILE_PARTS);
		errsound(ERROR);
      return 1;
      }
	while(readline(buffer,fp)!=NULL) {
   	if(buffer[0]==':') {
      	if(strcmp(buffer+1,part)==0) {
				if(readline(buffer,fp)!=NULL) {
   				if(buffer[0]!=':') strcpy(file,buffer);
	            else {
               	logfile(WARNING,"Format error in %s at %s",FILE_PARTS,part);
	   	         errsound(ERROR);
		            }
               }
            else {
            	logfile(WARNING,"Unexpected EOF on read of %s",FILE_PARTS);
	            errsound(ERROR);
               }
			   fclose(fp);
				return transfer2();
            }
			}
      }
   fclose(fp);
   logfile(WARNING,"Part not found in list: %s",part+2);
	errsound(ERROR);
   return 0;
	}
int transfer2(void) {
// declare and init
   int key;
   FILE *fp;
   char linebuffer[MAX_LENGTH];
	int programs=0;
   int prgcnt=0;
   int notfirst=0;
	int lastreturn=1;
   char buffer[2];
   char inbuf;
   char *ap="am";
   int hour=0;
   time_t timein;
   time_t timeout;
   window(2,4,79,lines-1);
   clrscr();
// TIME
	_dos_getdate(&d);
  	gettime(&t);
   cprintf("Transfering \"%s\" to \"%s\" on COM%d at ",part+2,nc[ncselect].name,nc[ncselect].commport);
   if(t.ti_hour >12) {hour=t.ti_hour-12; ap="pm";}
   else if (t.ti_hour > 0) {hour=t.ti_hour;}
   else hour = 12;
   cprintf("%d:%02d:%02d %s\r\n",hour,t.ti_min,t.ti_sec,ap);
	logfile(STATUS,"Transfering \"%s\" to \"%s\" on COM%d",part+2,nc[ncselect].name,nc[ncselect].commport);
// Program count
   if((fp=fopen(file,"r"))==NULL) {
     	logfile(WARNING,"Unable to open program file: %s",file);
		errsound(ERROR);
	  	cprintf("Unable open program file.\r\n");
     	cprintf("Press any key to return....\r\n");
		pause(timeout_key);
   	return 0;
      }
  	else logfile(DEBUG2,"MSG2 Opened program file: %s",file);
	while(readprgline(linebuffer,fp)!=NULL) {
		if(linebuffer[0]=='O') programs++;
     	}
// start transfer
	if(!serialopen(serialport(nc[ncselect].commport),serialbaud(nc[ncselect].baudrate),serialconf(nc[ncselect].databits,nc[ncselect].stopbits,nc[ncselect].parity)))
		logfile(WARNING,"Unable to open serial port. COM%d",nc[ncselect].commport);
	else logfile(DEBUG2,"MSG5 Opened serial port. COM%d",nc[ncselect].commport);
// start transfer code
	fseek(fp,0,SEEK_SET);
	if(programs>1 && firstlast) {
		while(readprgline(linebuffer,fp)!=NULL) {
			if(strcmp(linebuffer,"M30")==0) break;
	      }
      }
  	cprintf("Program %d of %d:\r\n\r\n",prgcnt+1,programs);
	notfirst=0;
  	if(term) {serialwrite(0x0A);serialwrite(0x0D);}
spag:
	while(fread(buffer,1,1,fp)!=0) {
	   if(buffer[0]=='O' && lastreturn && notfirst) {
			if(++prgcnt>=programs && firstlast) goto spag2;
			if(nc[ncselect].trans==1) {
				serialwrite('%');
	        	cprintf("\r\nPress any key to continue with program %d of %d....\r\n",prgcnt+1,programs);
				if(!(key=pause(timeout_key))) {
              	logfile(DEBUG1,"Key wait timed out.");
					errsound(ERROR);
              	cprintf("\r\nTransfer timed out....\r\n");
              	cprintf("\r\nPress any key to return....\r\n");
  	            pause(timeout_key);
					if(!serialclose())
						logfile(WARNING,"Unable to close serial port. COM%d",nc[ncselect].commport);
					else logfile(DEBUG2,"MSG8 Closed serial port. COM%d",nc[ncselect].commport);
			      fclose(fp);
					return 0;
               }
				if(key==0x1b) {
					if(!serialclose())
						logfile(WARNING,"Unable to close serial port. COM%d",nc[ncselect].commport);
					else logfile(DEBUG2,"MSG12 Closed serial port. COM%d",nc[ncselect].commport);
					fclose(fp);
	            return 0;
               }
				serialwrite(0x0A);
			  	if(term) serialwrite(0x0d);
      	   }
			else if(nc[ncselect].trans==2)
				if(interdelay>0)
   	         delay(interdelay);
		  	logfile(DEBUG2,"MSG7 Sent program %d of %d",prgcnt+1,programs);
	     	cprintf("Program %d of %d:\r\n\r\n",prgcnt+1,programs);
         lastreturn=0;
         }
      else if(buffer[0]=='O' && lastreturn) notfirst=1;
		if((inbuf=serialread())!=0) {
   	  	if(inbuf==XOFF) {
        	  	timein=time(NULL);
         	while(serialread()!=XON) {
           		timeout=time(NULL);
			   	if(timeout>timein+timeout_trans) {
                 	logfile(WARNING,"Transfer timed out.");
						errsound(ERROR);
                 	cprintf("\r\nTransfer timed out....\r\n");
                 	cprintf("\r\nPress any key to return....\r\n");
                  pause(timeout_key);
						if(!serialclose())
							logfile(DEBUG2,"MSG9 Unable to close serial port. COM%d",nc[ncselect].commport);
						else logfile(DEBUG2,"MSG10 Closed serial port. COM%d",nc[ncselect].commport);
				      fclose(fp);
						return 0;
						} //if timeout
               } //while xon
            }//if xoff
         }// if serialread
      if(buffer[0]!='%') {
        	serialwrite(buffer[0]);
         if(buffer[0]==0x0a) {
	        	if(term) serialwrite(0x0d);
           	cprintf("\r\n");
				lastreturn=1;
            }
         else {
           	cprintf("%c",buffer[0]);
				lastreturn=0;
            }
         }
		if(nc[ncselect].delay>0) {
			delay(nc[ncselect].delay);
			}
      }//while fread
	if(programs>1 && prgcnt<programs && firstlast) {
		fseek(fp,0,SEEK_SET);
		goto spag;
      }
spag2:
// end transfer code
  	logfile(DEBUG2,"MSG7 Sent program %d of %d",prgcnt+1,programs);
   fclose(fp);
  	logfile(DEBUG2,"MSG11 Closed program file: \"%s\"",file);
	serialwrite('%');
	if(!serialclose())
		logfile(WARNING,"Unable to close serial port. COM%d",nc[ncselect].commport);
	else logfile(DEBUG2,"MSG12 Closed serial port. COM%d",nc[ncselect].commport);
	errsound(SUCCESS);
  	cprintf("\r\nFinish transfering \"%s\" to \"%s\" on COM%d\n",part+2,nc[ncselect].name,nc[ncselect].commport);
	if(errlevel==DEBUG4) {
	  	cprintf("\r\nPress any key to return....\r\n");
	   pause(timeout_key);
      }
	return 0;
   }

